<?php
/**
 * Moodle mathtran filter. Accepts the same input format at the tex filter, but 
 * uses mathtran to render it instead.
 * 
 * Most of this nasty code is from the tex filter.
 *
 * @copyright &copy; 2007 The Open University
 * @author T.J.Hunt@open.ac.uk
 * @license http://www.gnu.org/copyleft/gpl.html GNU Public License
 * @package mathtran_filter
 *//** */

require_once($CFG->libdir . '/snoopy/Snoopy.class.inc');

function mathtran_filter($courseid, $text) {
    global $CFG;

    /// Do a quick check using stripos to avoid unnecessary work
    if (!preg_match('/<tex/i',$text) and !strstr($text,'$$') and !strstr($text,'\\[') and !preg_match('/\[tex/i',$text)) { //added one more tag (dlnsk)
        return $text;
    }

    $text .= ' ';
    preg_match_all('/\$(\$\$+?)([^\$])/s',$text,$matches);
    for ($i=0;$i<count($matches[0]);$i++) {
        $replacement = str_replace('$','&#x00024;',$matches[1][$i]).$matches[2][$i];
        $text = str_replace($matches[0][$i],$replacement,$text);
    }

    // <tex> TeX expression </tex>
    // or $$ TeX expression $$
    // or \[ TeX expression \]          // original tag of MathType and TeXaide (dlnsk)
    // or [tex] TeX expression [/tex]   // somtime it's more comfortable than <tex> (dlnsk)
    preg_match_all('/<tex>(.+?)<\/tex>|\$\$(.+?)\$\$|\\\\\[(.+?)\\\\\]|\\[tex\\](.+?)\\[\/tex\\]/is', $text, $matches);
    for ($i=0; $i<count($matches[0]); $i++) {
        // Clean up the match.
        $texexp = $matches[1][$i] . $matches[2][$i] . $matches[3][$i] . $matches[4][$i];
        $texexp = str_replace('<nolink>','',$texexp);
        $texexp = str_replace('</nolink>','',$texexp);
        $texexp = str_replace('<span class="nolink">','',$texexp);
        $texexp = str_replace('</span>','',$texexp);
        $texexp = eregi_replace("<br[[:space:]]*\/?>", '', $texexp);  //dlnsk
        $texexp = preg_replace('/^align=bottom /','',$texexp);
        $texexp = preg_replace('/^align=top /','',$texexp);
        
        // Fetch the image, to find the baseline adjustment.
        $url = 'http://mathtran.org/cgi-bin/mathtran?D=1;tex=' . urlencode($texexp);
        $snoopy = new Snoopy;
        $snoopy->fetch($url);
        $offset = '';
        $headermatches = array();
        foreach ($snoopy->headers as $header) {
            if (preg_match('/\s*X-MathImage-depth\s*:\s*(\d+)/', $header, $headermatches)) {
                $offset = 'style="vertical-align: -' . $headermatches[1] . 'px"';
                break;
            }
        }

        // Create the image tag.
        $text = str_replace( $matches[0][$i], "<img $offset src='" . s($url) . "' alt='" . s($texexp) . "' />", $text);
    }

    return $text; 
}


?>
